﻿#region Copyright © 2009 Marcel de Vries
/* This software is provided 'as-is', without any express or implied warranty.
 * In no event will the authors be held liable for any damages arising from the
 * use of this software.
 * 
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, subject to the following restrictions:
 * 
 * 1. The origin of this software must not be misrepresented; you must not
 *    claim that you wrote the original software. If you use this software in a
 *    product, an acknowledgment in the product documentation is requested, as
 *    shown here:
 * 
 *    Portions copyright © 2009 Marcel de Vries (http://blogs.infosupport.com/blogs/marcelv).
 * 
 * 2. No substantial portion of this source code may be redistributed without
 *    the express written permission of the copyright holders, where
 *    "substantial" is defined as enough code to be recognizably from this code.
 */
#endregion
using System;
using System.Windows.Forms;
using MSDNMagazine.TFSPlugins;
using Microsoft.TeamFoundation.VersionControl.Client;

namespace Dialogs
{
    public partial class AddNewSubstDefDialog : Form
    {

        VersionControlServer _vcs;

        string projectName;
        
        public AddNewSubstDefDialog(VersionControlServer vcs,  string currentProject)
        {
            InitializeComponent();
            this.Text = "Add new Definition";
            _vcs = vcs;
            projectName = currentProject;
            InitDriveSelector();
        }

        public AddNewSubstDefDialog(VersionControlServer vcs, string currentProject, string mappingName)
        {
            InitializeComponent();
            _vcs = vcs;
            projectName = currentProject;
            this.Text = "Edit Mapping Definition";
            var mapping = SubstConfigurationFile.GetMappingByName(currentProject, mappingName);

            txtMappingName.Text = mapping.name;
            txtVersionControlPath.Text = mapping.versionControlPath;
            string substDrive = mapping.drive;
            
            InitDriveSelector();
            
            int index = cbSubstDrive.Items.IndexOf(substDrive[0]);
            cbSubstDrive.SelectedIndex = index;
           
        }

        private void InitDriveSelector()
        {
            char[] possibleDrives = "DEFGHIJKLMNOPQRSTUVWXYZ".ToCharArray();
            cbSubstDrive.DataSource = possibleDrives;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            PicVCLocation locationSelector = new PicVCLocation(_vcs);
            locationSelector.LoadProjects();
            if (locationSelector.ShowDialog() != DialogResult.Cancel)
            {
                txtVersionControlPath.Text = locationSelector.ServerPath;
            }
        }

        

        public string VersionControlPath
        {
            get { return txtVersionControlPath.Text; }
        }
        public string SubstDriveLetter
        {
            get { return cbSubstDrive.SelectedValue.ToString(); }
        }

        public bool UseCurrentWorkspace
        {
            get { return true; }
        }

        public string substName
        {
            get { return txtMappingName.Text; }
        }

        private void btnOk_Click(object sender, EventArgs e)
        {

        }

    }
}
