﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Xml.Linq;
using InfoSupport.Endeavour.TFSPlugins;

namespace Dialogs
{
    public partial class RemoveSubstDefDialog : Form
    {
        string projectName;
        SubstConfigurationFile configFile;
        public RemoveSubstDefDialog(string currenProject)
        {
            InitializeComponent();
            
            projectName = currenProject;
            configFile = new SubstConfigurationFile();
            configFile.initialize();
            FillGridFromConfig();
        }

        private void FillGridFromConfig()
        {
            List<ListViewItem> items = new List<ListViewItem>();
            listView1.Items.Clear();

            IEnumerable<XElement> projectMappings = configFile.GetMappingsForProject(projectName);
            if (projectMappings != null)
            {
                foreach (XElement mapping in projectMappings)
                {
                    ListViewItem item = new ListViewItem();
                    item.Name = mapping.Attribute(SubstConfigurationFile.MAPPINGNAMEATTRIBUTE).Value;
                    item.SubItems.Add(mapping.Attribute(SubstConfigurationFile.MAPPINGSUBSTDRIVELETTERATTRIBUTE).Value);
                    item.SubItems.Add(mapping.Attribute(SubstConfigurationFile.MAPPINGVERSIONCONTROLATTRIBUTE).Value);
                    item.SubItems.Add(mapping.Attribute(SubstConfigurationFile.MAPPINGUSECURRENWORKSPACEATTRIBUTE).Value);
                    listView1.Items.Add(item);
                    item.Text = item.Name;
                }
            }
        }

        private void RemoveMappingFromFile(string removeName)
        {
            configFile.RemoveMappingFromProject(projectName,removeName);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            ListViewItem item = listView1.SelectedItems[0];
            if (item != null)
            {
                if (MessageBox.Show("Do you want to delete this mapping", "Delete mapping", MessageBoxButtons.OKCancel) != DialogResult.Cancel)
                {
                    RemoveMappingFromFile(item.Name);
                }
            }
            FillGridFromConfig();
        }

        private void OnKeyPress(object sender, KeyPressEventArgs e)
        {

        }

        private void RemoveSubstDefDialog_Load(object sender, EventArgs e)
        {

        }
    }
}
