﻿#region Copyright © 2009 Marcel de Vries
/* This software is provided 'as-is', without any express or implied warranty.
 * In no event will the authors be held liable for any damages arising from the
 * use of this software.
 * 
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, subject to the following restrictions:
 * 
 * 1. The origin of this software must not be misrepresented; you must not
 *    claim that you wrote the original software. If you use this software in a
 *    product, an acknowledgment in the product documentation is requested, as
 *    shown here:
 * 
 *    Portions copyright © 2009 Marcel de Vries (http://blogs.infosupport.com/blogs/marcelv).
 * 
 * 2. No substantial portion of this source code may be redistributed without
 *    the express written permission of the copyright holders, where
 *    "substantial" is defined as enough code to be recognizably from this code.
 */
#endregion
// MUST match Guids defined in CommandSet.vsct
using System;

namespace MSDNMagazine.TFSPlugins
{
    public static class GuidStrings
    {
        public const string GuidPackageCmdSet = "D0C59149-AC1D-4257-A68E-789592381830";
        public const string GuidPackage = "9B024C14-2F6F-4e38-AA67-3791524A807E";
    }

    static class GuidList
    {
        public static readonly Guid guidPackageCmdSet = new Guid(GuidStrings.GuidPackageCmdSet);
        public static readonly Guid guidClientPackage = new Guid(GuidStrings.GuidPackage);    
    };

    static class CommandList
    {       
      public const int mnuAdd = 0x1001;
      public const int mnuDelete = 0x1002;
      
      public const int grpAdd = 0x2001;
      public const int grpDelete = 0x2003; 
        
      public const int cmdAdd = 0x3001;
      public const int cmdDelete = 0x3002;
      public const int cmdEdit = 0x3003;

    }
}