﻿#region Copyright © 2009 Marcel de Vries
/* This software is provided 'as-is', without any express or implied warranty.
 * In no event will the authors be held liable for any damages arising from the
 * use of this software.
 * 
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, subject to the following restrictions:
 * 
 * 1. The origin of this software must not be misrepresented; you must not
 *    claim that you wrote the original software. If you use this software in a
 *    product, an acknowledgment in the product documentation is requested, as
 *    shown here:
 * 
 *    Portions copyright © 2009 Marcel de Vries (http://blogs.infosupport.com/blogs/marcelv).
 * 
 * 2. No substantial portion of this source code may be redistributed without
 *    the express written permission of the copyright holders, where
 *    "substantial" is defined as enough code to be recognizably from this code.
 */
#endregion
using System;
using System.ComponentModel.Design;
using System.Diagnostics;
using System.Globalization;
using System.Runtime.InteropServices;
using Microsoft.TeamFoundation.Common;
using Microsoft.VisualStudio.Shell;
using Microsoft.VisualStudio.Shell.Interop;
using Microsoft.VisualStudio.TeamFoundation;

[assembly:ComVisible(true)]

namespace MSDNMagazine.TFSPlugins
{
    [DefaultRegistryRoot("Software\\Microsoft\\VisualStudio\\9.0")]
    [InstalledProductRegistration(true, null, null, null)]
    [ProvideLoadKey("Professional", "1.0", "SubstExplorer", "vriesmarcel@hotmail.com", 101)]
	[ProvideService(typeof(SubstExplorer))]
    [ProvideMenuResource(1000,1)]
    [PluginRegistration(Catalogs.TeamProject, "Subst explorer", typeof(SubstExplorer))]
    [PackageRegistration(UseManagedResourcesOnly=true)]
    [Guid(GuidStrings.GuidPackage)]
    public sealed class SubstExplorerHostPackage : PluginHostPackage, IVsInstalledProduct
    {
        private static SubstExplorerHostPackage  _instance;
        public static SubstExplorerHostPackage  Instance
        {
            get { return _instance; }
        }

        public SubstExplorerHostPackage()
            : base()
        {
            _instance = this;
            Trace.WriteLine(string.Format(CultureInfo.CurrentCulture, "Entering constructor for: {0}", this.ToString()));
        }
        
        protected override object OnCreateService(IServiceContainer container, Type serviceType)
        {
            if (serviceType == typeof(SubstExplorer))
            {
                return new SubstExplorer();
            }
		    throw new ArgumentException(serviceType.ToString());
        }

        #region Package Members
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                GC.SuppressFinalize(this);
            }
            base.Dispose(disposing);
        }
        #endregion


        #region IVsInstalledProduct Members

        public int IdBmpSplash(out uint pIdBmp)
        {
            pIdBmp = 500;
            return Microsoft.VisualStudio.VSConstants.S_OK;
        }

        public int IdIcoLogoForAboutbox(out uint pIdIco)
        {
            pIdIco = 600;
            return Microsoft.VisualStudio.VSConstants.S_OK;
        }

        public int OfficialName(out string pbstrName)
        {
            pbstrName = "MSDN Subst Explorer";
            return Microsoft.VisualStudio.VSConstants.S_OK;
        }

        public int ProductDetails(out string pbstrProductDetails)
        {
            pbstrProductDetails = "Provides a Team Explorer plugin to subst a drive based on a pre defined mapping to version control";
            return Microsoft.VisualStudio.VSConstants.S_OK;
        }

        public int ProductID(out string pbstrPID)
        {
            pbstrPID = "1.0";
            return Microsoft.VisualStudio.VSConstants.S_OK;
        } 

        #endregion
    }


	

	
 }