﻿#region Copyright © 2009 Marcel de Vries
/* This software is provided 'as-is', without any express or implied warranty.
 * In no event will the authors be held liable for any damages arising from the
 * use of this software.
 * 
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, subject to the following restrictions:
 * 
 * 1. The origin of this software must not be misrepresented; you must not
 *    claim that you wrote the original software. If you use this software in a
 *    product, an acknowledgment in the product documentation is requested, as
 *    shown here:
 * 
 *    Portions copyright © 2009 Marcel de Vries (http://blogs.infosupport.com/blogs/marcelv).
 * 
 * 2. No substantial portion of this source code may be redistributed without
 *    the express written permission of the copyright holders, where
 *    "substantial" is defined as enough code to be recognizably from this code.
 */
#endregion
using System.ComponentModel.Design;
using System.Drawing;
using System.Reflection;
using Microsoft.TeamFoundation.Common;

namespace MSDNMagazine.TFSPlugins
{
    public class SubstExplorerRoot : RootNode
    {
        static private readonly CommandID command = new CommandID(GuidList.guidPackageCmdSet, CommandList.mnuAdd);

        public SubstExplorerRoot(string path)
            : base(path)
        {
            this.ImageIndex = 2;
            NodePriority  = (int)TeamExplorerNodePriority.Folder;
            SetCorrectIconHandles();
        }

        
        private void SetCorrectIconHandles()
        {
            // default icon is non substed drive... index 0;
            FieldInfo fieldInfo = typeof(BaseHierarchyNode).GetField("m_iconHandle", BindingFlags.FlattenHierarchy | BindingFlags.Instance | BindingFlags.NonPublic);
            fieldInfo.SetValue(this, new Bitmap(SubstConfigurationFile.GetCommandImages().Images[2]).GetHicon());

            fieldInfo = typeof(BaseHierarchyNode).GetField("m_openFoderIconHandle", BindingFlags.FlattenHierarchy | BindingFlags.Instance | BindingFlags.NonPublic);
            fieldInfo.SetValue(this, new Bitmap(SubstConfigurationFile.GetCommandImages().Images[2]).GetHicon());
        }

        public override System.Windows.Forms.ImageList Icons
        {
            get
            {
                return SubstConfigurationFile.GetCommandImages();
            }
        }

        public override string PropertiesClassName
        {
            //Name of the node to show in tje properties window
            get { return "Subst Explorer Root"; }
        }

        public override System.ComponentModel.Design.CommandID ContextMenu
        {
            get
            {
                return command;
            }
        }

    }

}
